diff -crBPN --exclude=.wp-config.php.swp --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.1.pl ./wordpress-3.4/wp-admin/about.php ./wordpress-3.4.1/wp-admin/about.php
*** ./wordpress-3.4/wp-admin/about.php	2012-06-01 20:16:35.000000000 -0500
--- ./wordpress-3.4.1/wp-admin/about.php	2012-06-27 14:29:16.000000000 -0500
***************
*** 33,38 ****
--- 33,46 ----
  	</a>
  </h2>
  
+ <div class="changelog point-releases">
+ 	<h3><?php echo _n( 'Maintenance and Security Release', 'Maintenance and Security Releases', 1 ); ?></h3>
+ 	<p><?php printf( _n( '<strong>Version %1$s</strong> addressed some security issues and fixed %2$s bug.',
+          '<strong>Version %1$s</strong> addressed some security issues and fixed %2$s bugs.', 21 ), '3.4.1', number_format_i18n( 21 ) ); ?>
+ 		<?php printf( __( 'For more information, see <a href="%s">the release notes</a>.' ), 'http://codex.wordpress.org/Version_3.4.1' ); ?>
+  	</p>
+ </div>
+ 
  <div class="changelog">
  	<h3><?php _e( 'Live Theme Previews' ); ?></h3>
  
diff -crBPN --exclude=.wp-config.php.swp --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.1.pl ./wordpress-3.4/wp-admin/customize.php ./wordpress-3.4.1/wp-admin/customize.php
*** ./wordpress-3.4/wp-admin/customize.php	2012-06-12 13:39:16.000000000 -0500
--- ./wordpress-3.4.1/wp-admin/customize.php	2012-06-26 13:53:45.000000000 -0500
***************
*** 7,12 ****
--- 7,14 ----
   * @since 3.4.0
   */
  
+ define( 'IFRAME_REQUEST', true );
+ 
  require_once( './admin.php' );
  if ( ! current_user_can( 'edit_theme_options' ) )
  	wp_die( __( 'Cheatin&#8217; uh?' ) );
***************
*** 65,71 ****
  <body class="<?php echo esc_attr( $body_class ); ?>">
  <div class="wp-full-overlay expanded">
  	<form id="customize-controls" class="wrap wp-full-overlay-sidebar">
- 		<?php wp_nonce_field( 'customize_controls-' . $wp_customize->get_stylesheet() ); ?>
  		<div id="customize-header-actions" class="wp-full-overlay-header">
  			<?php
  				$save_text = $wp_customize->is_theme_active() ? __( 'Save &amp; Publish' ) : __( 'Save &amp; Activate' );
--- 67,72 ----
***************
*** 175,180 ****
--- 176,185 ----
  		),
  		'settings' => array(),
  		'controls' => array(),
+ 		'nonce'    => array(
+  			'save'    => wp_create_nonce( 'save-customize_' . $wp_customize->get_stylesheet() ),
+  			'preview' => wp_create_nonce( 'preview-customize_' . $wp_customize->get_stylesheet() )
+  		),
  	);
  
  	foreach ( $wp_customize->settings() as $id => $setting ) {
diff -crBPN --exclude=.wp-config.php.swp --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.1.pl ./wordpress-3.4/wp-admin/includes/meta-boxes.php ./wordpress-3.4.1/wp-admin/includes/meta-boxes.php
*** ./wordpress-3.4/wp-admin/includes/meta-boxes.php	2012-05-25 08:45:16.000000000 -0500
--- ./wordpress-3.4.1/wp-admin/includes/meta-boxes.php	2012-06-25 14:59:10.000000000 -0500
***************
*** 483,499 ****
  	if ( 1 > $total ) {
  		echo '<p id="no-comments">' . __('No comments yet.') . '</p>';
  	} else {
! 		$hidden = get_hidden_meta_boxes('post');
  		if ( ! in_array('commentsdiv', $hidden) ) {
  			?>
  			<script type="text/javascript">jQuery(document).ready(function(){commentsBox.get(<?php echo $total; ?>, 10);});</script>
  			<?php
  		}
- 	}
  
! 	?>
! 	<p class="hide-if-no-js hidden" id="show-comments"><a href="#commentstatusdiv" onclick="commentsBox.get(<?php echo $total; ?>);return false;"><?php _e('Show comments'); ?></a> <img class="waiting" style="display:none;" src="<?php echo esc_url( admin_url( 'images/wpspin_light.gif' ) ); ?>" alt="" /></p>
! 	<?php
  
  	wp_comment_trashnotice();
  }
--- 483,499 ----
  	if ( 1 > $total ) {
  		echo '<p id="no-comments">' . __('No comments yet.') . '</p>';
  	} else {
! 		$hidden = get_hidden_meta_boxes( get_current_screen() );
  		if ( ! in_array('commentsdiv', $hidden) ) {
  			?>
  			<script type="text/javascript">jQuery(document).ready(function(){commentsBox.get(<?php echo $total; ?>, 10);});</script>
  			<?php
  		}
  
! 		?>
! 		<p class="hide-if-no-js" id="show-comments"><a href="#commentstatusdiv" onclick="commentsBox.get(<?php echo $total; ?>);return false;"><?php _e('Show comments'); ?></a> <img class="waiting" style="display:none;" src="<?php echo esc_url( admin_url( 'images/wpspin_light.gif' ) ); ?>" alt="" /></p>
! 		<?php
! 	}
  
  	wp_comment_trashnotice();
  }
diff -crBPN --exclude=.wp-config.php.swp --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.1.pl ./wordpress-3.4/wp-admin/includes/plugin.php ./wordpress-3.4.1/wp-admin/includes/plugin.php
*** ./wordpress-3.4/wp-admin/includes/plugin.php	2012-04-20 19:45:53.000000000 -0500
--- ./wordpress-3.4.1/wp-admin/includes/plugin.php	2012-06-25 23:03:31.000000000 -0500
***************
*** 521,526 ****
--- 521,527 ----
  	if ( is_multisite() && ( $network_wide || is_network_only_plugin($plugin) ) ) {
  		$network_wide = true;
  		$current = get_site_option( 'active_sitewide_plugins', array() );
+ 		$_GET['networkwide'] = 1; // Back compat for plugins looking for this value.
  	} else {
  		$current = get_option( 'active_plugins', array() );
  	}
diff -crBPN --exclude=.wp-config.php.swp --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.1.pl ./wordpress-3.4/wp-admin/includes/update-core.php ./wordpress-3.4.1/wp-admin/includes/update-core.php
*** ./wordpress-3.4/wp-admin/includes/update-core.php	2012-05-25 13:12:29.000000000 -0500
--- ./wordpress-3.4.1/wp-admin/includes/update-core.php	2012-06-26 16:54:32.000000000 -0500
***************
*** 477,483 ****
  	$mysql_version  = $wpdb->db_version();
  	$required_php_version = '5.2.4';
  	$required_mysql_version = '5.0';
! 	$wp_version = '3.4';
  	$php_compat     = version_compare( $php_version, $required_php_version, '>=' );
  	if ( file_exists( WP_CONTENT_DIR . '/db.php' ) && empty( $wpdb->is_mysql ) )
  		$mysql_compat = true;
--- 477,483 ----
  	$mysql_version  = $wpdb->db_version();
  	$required_php_version = '5.2.4';
  	$required_mysql_version = '5.0';
! 	$wp_version = '3.4.1';
  	$php_compat     = version_compare( $php_version, $required_php_version, '>=' );
  	if ( file_exists( WP_CONTENT_DIR . '/db.php' ) && empty( $wpdb->is_mysql ) )
  		$mysql_compat = true;
diff -crBPN --exclude=.wp-config.php.swp --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.1.pl ./wordpress-3.4/wp-admin/includes/update.php ./wordpress-3.4.1/wp-admin/includes/update.php
*** ./wordpress-3.4/wp-admin/includes/update.php	2012-05-03 11:41:59.000000000 -0500
--- ./wordpress-3.4.1/wp-admin/includes/update.php	2012-06-25 15:30:59.000000000 -0500
***************
*** 264,270 ****
  	$themes_allowedtags = array('a' => array('href' => array(),'title' => array()),'abbr' => array('title' => array()),'acronym' => array('title' => array()),'code' => array(),'em' => array(),'strong' => array());
  	$theme_name = wp_kses( $theme['Name'], $themes_allowedtags );
  
! 	$details_url = self_admin_url("theme-install.php?tab=theme-information&theme=$theme_key&TB_iframe=true&width=600&height=400");
  
  	$wp_list_table = _get_list_table('WP_MS_Themes_List_Table');
  
--- 264,270 ----
  	$themes_allowedtags = array('a' => array('href' => array(),'title' => array()),'abbr' => array('title' => array()),'acronym' => array('title' => array()),'code' => array(),'em' => array(),'strong' => array());
  	$theme_name = wp_kses( $theme['Name'], $themes_allowedtags );
  
! 	$details_url = add_query_arg( array( 'TB_iframe' => 'true', 'width' => 1024, 'height' => 800 ), $current->response[ $theme_key ]['url'] );
  
  	$wp_list_table = _get_list_table('WP_MS_Themes_List_Table');
  
diff -crBPN --exclude=.wp-config.php.swp --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.1.pl ./wordpress-3.4/wp-admin/js/common.dev.js ./wordpress-3.4.1/wp-admin/js/common.dev.js
*** ./wordpress-3.4/wp-admin/js/common.dev.js	2012-06-12 11:36:32.000000000 -0500
--- ./wordpress-3.4.1/wp-admin/js/common.dev.js	2012-06-20 19:10:05.000000000 -0500
***************
*** 216,222 ****
  			m.addClass('sub-open');
  		},
  		out: function(){
! 			$(this).find('.wp-submenu').removeClass('sub-open');
  		},
  		timeout: 200,
  		sensitivity: 7,
--- 216,222 ----
  			m.addClass('sub-open');
  		},
  		out: function(){
! 			$(this).find('.wp-submenu').removeClass('sub-open').css('margin-top', '');
  		},
  		timeout: 200,
  		sensitivity: 7,
diff -crBPN --exclude=.wp-config.php.swp --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.1.pl ./wordpress-3.4/wp-admin/js/customize-controls.dev.js ./wordpress-3.4.1/wp-admin/js/customize-controls.dev.js
*** ./wordpress-3.4/wp-admin/js/customize-controls.dev.js	2012-06-12 17:51:55.000000000 -0500
--- ./wordpress-3.4.1/wp-admin/js/customize-controls.dev.js	2012-06-26 13:53:45.000000000 -0500
***************
*** 294,300 ****
  			// This is the promise object.
  			deferred.promise( this );
  
! 			this.previewer = params.previewer;
  
  			$.extend( params, { channel: api.PreviewFrame.uuid() });
  
--- 294,301 ----
  			// This is the promise object.
  			deferred.promise( this );
  
! 			this.container = params.container;
! 			this.signature = params.signature;
  
  			$.extend( params, { channel: api.PreviewFrame.uuid() });
  
***************
*** 338,344 ****
  
  			this.request.done( function( response ) {
  				var location = self.request.getResponseHeader('Location'),
! 					signature = 'WP_CUSTOMIZER_SIGNATURE',
  					index;
  
  				// Check if the location response header differs from the current URL.
--- 339,345 ----
  
  			this.request.done( function( response ) {
  				var location = self.request.getResponseHeader('Location'),
! 					signature = self.signature,
  					index;
  
  				// Check if the location response header differs from the current URL.
***************
*** 371,377 ****
  				response = response.slice( 0, index ) + response.slice( index + signature.length );
  
  				// Create the iframe and inject the html content.
! 				self.iframe = $('<iframe />').appendTo( self.previewer.container );
  
  				// Bind load event after the iframe has been added to the page;
  				// otherwise it will fire when injected into the DOM.
--- 372,378 ----
  				response = response.slice( 0, index ) + response.slice( index + signature.length );
  
  				// Create the iframe and inject the html content.
! 				self.iframe = $('<iframe />').appendTo( self.container );
  
  				// Bind load event after the iframe has been added to the page;
  				// otherwise it will fire when injected into the DOM.
***************
*** 416,422 ****
  					reject();
  
  				iframe = $('<iframe src="' + self.previewUrl() + '" />').hide();
! 				iframe.appendTo( self.previewer.container );
  				iframe.load( function() {
  					self.triedLogin = true;
  
--- 417,423 ----
  					reject();
  
  				iframe = $('<iframe src="' + self.previewUrl() + '" />').hide();
! 				iframe.appendTo( self.container );
  				iframe.load( function() {
  					self.triedLogin = true;
  
***************
*** 497,502 ****
--- 498,504 ----
  
  			this.container   = api.ensure( params.container );
  			this.allowedUrls = params.allowedUrls;
+ 			this.signature   = params.signature;
  
  			params.url = window.location.href;
  
***************
*** 570,576 ****
  				url:        this.url(),
  				previewUrl: this.previewUrl(),
  				query:      this.query() || {},
! 				previewer:  this
  			});
  
  			this.loading.done( function() {
--- 572,579 ----
  				url:        this.url(),
  				previewUrl: this.previewUrl(),
  				query:      this.query() || {},
! 				container:  this.container,
! 				signature:  this.signature
  			});
  
  			this.loading.done( function() {
***************
*** 583,588 ****
--- 586,593 ----
  
  					self.targetWindow( this.targetWindow() );
  					self.channel( this.channel() );
+ 
+ 					self.send( 'active' );
  				});
  
  				this.send( 'sync', {
***************
*** 683,705 ****
  			container:   '#customize-preview',
  			form:        '#customize-controls',
  			previewUrl:  api.settings.url.preview,
! 			allowedUrls: api.settings.url.allowed
  		}, {
  			query: function() {
  				return {
  					wp_customize: 'on',
  					theme:        api.settings.theme.stylesheet,
! 					customized:   JSON.stringify( api.get() )
  				};
  			},
  
- 			nonce: $('#_wpnonce').val(),
- 
  			save: function() {
  				var self  = this,
  					query = $.extend( this.query(), {
  						action: 'customize_save',
! 						nonce:  this.nonce
  					}),
  					request = $.post( api.settings.url.ajax, query );
  
--- 688,713 ----
  			container:   '#customize-preview',
  			form:        '#customize-controls',
  			previewUrl:  api.settings.url.preview,
! 			allowedUrls: api.settings.url.allowed,
! 			signature:   'WP_CUSTOMIZER_SIGNATURE'
  		}, {
+ 
+ 			nonce: api.settings.nonce,
+ 
  			query: function() {
  				return {
  					wp_customize: 'on',
  					theme:        api.settings.theme.stylesheet,
! 					customized:   JSON.stringify( api.get() ),
! 					nonce:        this.nonce.preview
  				};
  			},
  
  			save: function() {
  				var self  = this,
  					query = $.extend( this.query(), {
  						action: 'customize_save',
! 						nonce:  this.nonce.save
  					}),
  					request = $.post( api.settings.url.ajax, query );
  
***************
*** 733,738 ****
--- 741,751 ----
  			}
  		});
  
+ 		// Refresh the nonces if the preview sends updated nonces over.
+  		previewer.bind( 'nonce', function( nonce ) {
+  			$.extend( this.nonce, nonce );
+  		});
+ 
  		$.each( api.settings.settings, function( id, data ) {
  			api.create( id, id, data.value, {
  				transport: data.transport,
diff -crBPN --exclude=.wp-config.php.swp --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.1.pl ./wordpress-3.4/wp-admin/load-scripts.php ./wordpress-3.4.1/wp-admin/load-scripts.php
*** ./wordpress-3.4/wp-admin/load-scripts.php	2012-01-05 14:10:39.000000000 -0600
--- ./wordpress-3.4.1/wp-admin/load-scripts.php	2012-06-26 01:28:59.000000000 -0500
***************
*** 54,59 ****
--- 54,64 ----
  /**
   * @ignore
   */
+ function did_action() {}
+ 
+ /**
+  * @ignore
+  */
  function do_action_ref_array() {}
  
  /**
diff -crBPN --exclude=.wp-config.php.swp --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.1.pl ./wordpress-3.4/wp-admin/themes.php ./wordpress-3.4.1/wp-admin/themes.php
*** ./wordpress-3.4/wp-admin/themes.php	2012-06-12 13:39:16.000000000 -0500
--- ./wordpress-3.4.1/wp-admin/themes.php	2012-06-26 14:10:05.000000000 -0500
***************
*** 20,26 ****
  		$theme = wp_get_theme( $_GET['stylesheet'] );
  		if ( ! $theme->exists() || ! $theme->is_allowed() )
  			wp_die( __( 'Cheatin&#8217; uh?' ) );
! 		switch_theme($_GET['template'], $_GET['stylesheet']);
  		wp_redirect( admin_url('themes.php?activated=true') );
  		exit;
  	} elseif ( 'delete' == $_GET['action'] ) {
--- 20,26 ----
  		$theme = wp_get_theme( $_GET['stylesheet'] );
  		if ( ! $theme->exists() || ! $theme->is_allowed() )
  			wp_die( __( 'Cheatin&#8217; uh?' ) );
! 		switch_theme( $theme->get_template(), $theme->get_stylesheet() );
  		wp_redirect( admin_url('themes.php?activated=true') );
  		exit;
  	} elseif ( 'delete' == $_GET['action'] ) {
***************
*** 64,69 ****
--- 64,71 ----
  	) );
  }
  
+ add_thickbox();
+ 
  endif; // switch_themes
  
  if ( current_user_can( 'edit_theme_options' ) ) {
diff -crBPN --exclude=.wp-config.php.swp --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.1.pl ./wordpress-3.4/wp-includes/canonical.php ./wordpress-3.4.1/wp-includes/canonical.php
*** ./wordpress-3.4/wp-includes/canonical.php	2012-05-02 12:39:43.000000000 -0500
--- ./wordpress-3.4.1/wp-includes/canonical.php	2012-06-25 15:51:16.000000000 -0500
***************
*** 100,106 ****
  		}
  
  		if ( ! $redirect_url ) {
! 			if ( $redirect_url = redirect_guess_404_permalink( $requested_url ) ) {
  				$redirect['query'] = _remove_qs_args_if_not_in_url( $redirect['query'], array( 'page', 'feed', 'p', 'page_id', 'attachment_id', 'pagename', 'name', 'post_type' ), $redirect_url );
  			}
  		}
--- 100,106 ----
  		}
  
  		if ( ! $redirect_url ) {
! 			if ( $redirect_url = redirect_guess_404_permalink() ) {
  				$redirect['query'] = _remove_qs_args_if_not_in_url( $redirect['query'], array( 'page', 'feed', 'p', 'page_id', 'attachment_id', 'pagename', 'name', 'post_type' ), $redirect_url );
  			}
  		}
***************
*** 461,491 ****
  }
  
  /**
!  * Attempts to guess the correct URL from the current URL (that produced a 404) or
!  * the current query variables.
   *
   * @since 2.3.0
   * @uses $wpdb
   *
-  * @param string $current_url Optional. The URL that has 404'd.
   * @return bool|string The correct URL if one is found. False on failure.
   */
! function redirect_guess_404_permalink( $current_url = '' ) {
  	global $wpdb, $wp_rewrite;
  
- 	if ( ! empty( $current_url ) )
- 		$parsed_url = @parse_url( $current_url );
- 
- 	// Attempt to redirect bare category slugs if the permalink structure starts
- 	// with the %category% tag.
- 	if ( isset( $parsed_url['path'] )
- 		&& preg_match( '#^[^%]+%category%#', $wp_rewrite->permalink_structure )
- 		&& $cat = get_category_by_path( $parsed_url['path'] )
- 	) {
- 		if ( ! is_wp_error( $cat ) )
- 			return get_term_link( $cat );
- 	}
- 
  	if ( get_query_var('name') ) {
  		$where = $wpdb->prepare("post_name LIKE %s", like_escape( get_query_var('name') ) . '%');
  
--- 461,476 ----
  }
  
  /**
!  * Attempts to guess the correct URL based on query vars
   *
   * @since 2.3.0
   * @uses $wpdb
   *
   * @return bool|string The correct URL if one is found. False on failure.
   */
! function redirect_guess_404_permalink() {
  	global $wpdb, $wp_rewrite;
  
  	if ( get_query_var('name') ) {
  		$where = $wpdb->prepare("post_name LIKE %s", like_escape( get_query_var('name') ) . '%');
  
diff -crBPN --exclude=.wp-config.php.swp --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.1.pl ./wordpress-3.4/wp-includes/capabilities.php ./wordpress-3.4.1/wp-includes/capabilities.php
*** ./wordpress-3.4/wp-includes/capabilities.php	2012-06-12 08:50:51.000000000 -0500
--- ./wordpress-3.4.1/wp-includes/capabilities.php	2012-06-27 14:29:16.000000000 -0500
***************
*** 1130,1135 ****
--- 1130,1137 ----
  		// Disallow unfiltered_html for all users, even admins and super admins.
  		if ( defined( 'DISALLOW_UNFILTERED_HTML' ) && DISALLOW_UNFILTERED_HTML )
  			$caps[] = 'do_not_allow';
+ 		elseif ( is_multisite() && ! is_super_admin( $user_id ) )
+ 			$caps[] = $cap;
  		else
  			$caps[] = $cap;
  		break;
diff -crBPN --exclude=.wp-config.php.swp --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.1.pl ./wordpress-3.4/wp-includes/class-phpmailer.php ./wordpress-3.4.1/wp-includes/class-phpmailer.php
*** ./wordpress-3.4/wp-includes/class-phpmailer.php	2012-05-03 11:41:59.000000000 -0500
--- ./wordpress-3.4.1/wp-includes/class-phpmailer.php	2012-06-25 22:55:40.000000000 -0500
***************
*** 760,772 ****
      } else {
        if ($this->SingleTo === true && count($toArr) > 1) {
          foreach ($toArr as $key => $val) {
!           $rt = @mail($val, $this->EncodeHeader($this->SecureHeader($this->Subject)), $body, $header, $params);
            // implement call back function if it exists
            $isSent = ($rt == 1) ? 1 : 0;
            $this->doCallback($isSent, $val, $this->cc, $this->bcc, $this->Subject, $body);
          }
        } else {
!         $rt = @mail($to, $this->EncodeHeader($this->SecureHeader($this->Subject)), $body, $header, $params);
          // implement call back function if it exists
          $isSent = ($rt == 1) ? 1 : 0;
          $this->doCallback($isSent, $to, $this->cc, $this->bcc, $this->Subject, $body);
--- 760,772 ----
      } else {
        if ($this->SingleTo === true && count($toArr) > 1) {
          foreach ($toArr as $key => $val) {
!           $rt = @mail($val, $this->EncodeHeader($this->SecureHeader($this->Subject)), $body, $header);
            // implement call back function if it exists
            $isSent = ($rt == 1) ? 1 : 0;
            $this->doCallback($isSent, $val, $this->cc, $this->bcc, $this->Subject, $body);
          }
        } else {
!         $rt = @mail($to, $this->EncodeHeader($this->SecureHeader($this->Subject)), $body, $header);
          // implement call back function if it exists
          $isSent = ($rt == 1) ? 1 : 0;
          $this->doCallback($isSent, $to, $this->cc, $this->bcc, $this->Subject, $body);
diff -crBPN --exclude=.wp-config.php.swp --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.1.pl ./wordpress-3.4/wp-includes/class-wp-customize-manager.php ./wordpress-3.4.1/wp-includes/class-wp-customize-manager.php
*** ./wordpress-3.4/wp-includes/class-wp-customize-manager.php	2012-06-12 14:27:41.000000000 -0500
--- ./wordpress-3.4.1/wp-includes/class-wp-customize-manager.php	2012-06-26 13:53:45.000000000 -0500
***************
*** 17,22 ****
--- 17,24 ----
  	protected $sections = array();
  	protected $controls = array();
  
+ 	protected $nonce_tick;
+ 
  	protected $customized;
  
  	private $_post_values;
***************
*** 308,313 ****
--- 310,317 ----
  	 * @since 3.4.0
  	 */
  	public function customize_preview_init() {
+ 		$this->nonce_tick = check_ajax_referer( 'preview-customize_' . $this->get_stylesheet(), 'nonce' );
+ 
  		$this->prepare_controls();
  
  		wp_enqueue_script( 'customize-preview' );
***************
*** 362,367 ****
--- 366,378 ----
  			'channel' => esc_js( $_POST['customize_messenger_channel'] ),
  		);
  
+ 		if ( 2 == $this->nonce_tick ) {
+  			$settings['nonce'] = array(
+  				'save' => wp_create_nonce( 'save-customize_' . $this->get_stylesheet() ),
+  				'preview' => wp_create_nonce( 'preview-customize_' . $this->get_stylesheet() )
+  			);
+  		}
+ 
  		foreach ( $this->settings as $id => $setting ) {
  			$settings['values'][ $id ] = $setting->js_value();
  		}
***************
*** 468,474 ****
  		if ( ! $this->is_preview() )
  			die;
  
! 		check_ajax_referer( 'customize_controls-' . $this->get_stylesheet(), 'nonce' );
  
  		// Do we have to switch themes?
  		if ( ! $this->is_theme_active() ) {
--- 479,485 ----
  		if ( ! $this->is_preview() )
  			die;
  
! 		check_ajax_referer( 'save-customize_' . $this->get_stylesheet(), 'nonce' );
  
  		// Do we have to switch themes?
  		if ( ! $this->is_theme_active() ) {
diff -crBPN --exclude=.wp-config.php.swp --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.1.pl ./wordpress-3.4/wp-includes/class-wp-editor.php ./wordpress-3.4.1/wp-includes/class-wp-editor.php
*** ./wordpress-3.4/wp-includes/class-wp-editor.php	2012-04-02 17:26:11.000000000 -0500
--- ./wordpress-3.4.1/wp-includes/class-wp-editor.php	2012-06-25 22:10:49.000000000 -0500
***************
*** 337,343 ****
  						foreach ( $editor_styles as $key => $file ) {
  							if ( $file && file_exists( "$template_dir/$file" ) ) {
  								$mce_css[] = "$template_uri/$file";
- 								$editor_styles[$key] = '';
  							}
  						}
  					}
--- 337,342 ----
diff -crBPN --exclude=.wp-config.php.swp --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.1.pl ./wordpress-3.4/wp-includes/class.wp-scripts.php ./wordpress-3.4.1/wp-includes/class.wp-scripts.php
*** ./wordpress-3.4/wp-includes/class.wp-scripts.php	2012-02-27 13:46:52.000000000 -0600
--- ./wordpress-3.4.1/wp-includes/class.wp-scripts.php	2012-06-26 01:28:59.000000000 -0500
***************
*** 31,40 ****
  	var $default_dirs;
  
  	function __construct() {
! 		if ( ! function_exists( 'did_action' ) || did_action( 'init' ) )
! 			$this->init();
! 		else
! 			add_action( 'init', array( $this, 'init' ), 0 );
  	}
  
  	function init() {
--- 31,38 ----
  	var $default_dirs;
  
  	function __construct() {
! 		$this->init();
! 		add_action( 'init', array( $this, 'init' ), 0 );
  	}
  
  	function init() {
diff -crBPN --exclude=.wp-config.php.swp --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.1.pl ./wordpress-3.4/wp-includes/class-wp-theme.php ./wordpress-3.4.1/wp-includes/class-wp-theme.php
*** ./wordpress-3.4/wp-includes/class-wp-theme.php	2012-06-11 12:30:57.000000000 -0500
--- ./wordpress-3.4.1/wp-includes/class-wp-theme.php	2012-06-25 22:07:18.000000000 -0500
***************
*** 930,939 ****
  			$files = (array) $this->get_files( 'php', 1 );
  
  			foreach ( $files as $file => $full_path ) {
! 				$headers = get_file_data( $full_path, array( 'Template Name' => 'Template Name' ) );
! 				if ( empty( $headers['Template Name'] ) )
  					continue;
! 				$page_templates[ $file ] = $headers['Template Name'];
  			}
  
  			$this->cache_add( 'page_templates', $page_templates );
--- 930,938 ----
  			$files = (array) $this->get_files( 'php', 1 );
  
  			foreach ( $files as $file => $full_path ) {
! 				if ( ! preg_match( '|Template Name:(.*)$|mi', file_get_contents( $full_path ), $header ) )
  					continue;
! 				$page_templates[ $file ] = _cleanup_header_comment( $header[1] );
  			}
  
  			$this->cache_add( 'page_templates', $page_templates );
diff -crBPN --exclude=.wp-config.php.swp --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.1.pl ./wordpress-3.4/wp-includes/class-wp-xmlrpc-server.php ./wordpress-3.4.1/wp-includes/class-wp-xmlrpc-server.php
*** ./wordpress-3.4/wp-includes/class-wp-xmlrpc-server.php	2012-06-05 11:25:05.000000000 -0500
--- ./wordpress-3.4.1/wp-includes/class-wp-xmlrpc-server.php	2012-06-26 14:04:41.000000000 -0500
***************
*** 1337,1343 ****
  			return new IXR_Error( 404, __( 'Invalid post ID.' ) );
  
  		$post_type = get_post_type_object( $post['post_type'] );
! 		if ( ! current_user_can( $post_type->cap->edit_posts, $post_id ) )
  			return new IXR_Error( 401, __( 'Sorry, you cannot edit this post.' ) );
  
  		return $this->_prepare_post( $post, $fields );
--- 1337,1343 ----
  			return new IXR_Error( 404, __( 'Invalid post ID.' ) );
  
  		$post_type = get_post_type_object( $post['post_type'] );
! 		if ( ! current_user_can( $post_type->cap->edit_post, $post_id ) )
  			return new IXR_Error( 401, __( 'Sorry, you cannot edit this post.' ) );
  
  		return $this->_prepare_post( $post, $fields );
***************
*** 1394,1405 ****
  			$post_type = get_post_type_object( $filter['post_type'] );
  			if ( ! ( (bool) $post_type ) )
  				return new IXR_Error( 403, __( 'The post type specified is not valid' ) );
  
! 			if ( ! current_user_can( $post_type->cap->edit_posts ) )
! 				return new IXR_Error( 401, __( 'Sorry, you are not allowed to edit posts in this post type' ));
  
! 			$query['post_type'] = $filter['post_type'];
! 		}
  
  		if ( isset( $filter['post_status'] ) )
  			$query['post_status'] = $filter['post_status'];
--- 1394,1407 ----
  			$post_type = get_post_type_object( $filter['post_type'] );
  			if ( ! ( (bool) $post_type ) )
  				return new IXR_Error( 403, __( 'The post type specified is not valid' ) );
+ 		} else {
+ 			$post_type = get_post_type_object( 'post' );
+ 		}
  
! 		if ( ! current_user_can( $post_type->cap->edit_posts ) )
! 			return new IXR_Error( 401, __( 'Sorry, you are not allowed to edit posts in this post type' ));
  
! 		$query['post_type'] = $post_type->name;
  
  		if ( isset( $filter['post_status'] ) )
  			$query['post_status'] = $filter['post_status'];
***************
*** 1427,1433 ****
  
  		foreach ( $posts_list as $post ) {
  			$post_type = get_post_type_object( $post['post_type'] );
! 			if ( ! current_user_can( $post_type->cap->edit_posts, $post['ID'] ) )
  				continue;
  
  			$struct[] = $this->_prepare_post( $post, $fields );
--- 1429,1435 ----
  
  		foreach ( $posts_list as $post ) {
  			$post_type = get_post_type_object( $post['post_type'] );
! 			if ( ! current_user_can( $post_type->cap->edit_post, $post['ID'] ) )
  				continue;
  
  			$struct[] = $this->_prepare_post( $post, $fields );
